﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Net;
//using System.IO;
//using System.Net.Sockets;
using System.Management;
using System.Windows.Forms;
using System.Runtime.InteropServices;  //api

namespace Ethernet_data
{
    class Class3
    {
        [DllImport("ws2_32.dll")]
        private static extern int inet_addr(string cp);
        [DllImport("IPHLPAPI.dll")]
        private static extern int SendARP(Int32 DestIP, Int32 SrcIP, ref Int64 pMacAddr, ref Int32 PhyAddrLen);


        public static bool getNetwork(ref string[] list)
        {
            ManagementClass mc = new ManagementClass("Win32_NetworkAdapterConfiguration"); 
            ManagementObjectCollection nics = mc.GetInstances(); 
            foreach (ManagementObject nic in nics) 
            { 
                if (Convert.ToBoolean(nic["ipEnabled"]) == true) 
                {
                    list[0]=(nic["IPAddress"] as String[])[0];
                    list[1] = (nic["IPSubnet"] as String[])[0];
                    list[2] = (nic["DefaultIPGateway"] as String[])[0];
                    return true;
                } 
            }
            return false;
        }
        /*public static string getip() //ipv4 ip
        {
            string IP = null;
            IPAddress[] addrList = Dns.GetHostEntry(Dns.GetHostName()).AddressList;
            for (int i = 0; i < addrList.Length; i++)
            {
                if (addrList[i].AddressFamily.ToString() == ProtocolFamily.InterNetwork.ToString())
                {
                    IP= addrList[i].ToString();//获得IP4地址  
                    break;
                }
            }
            return IP;
        }*/
        public static string ScanTarget(string ip)
        {
            string strIPAddress = ip;
            int nStrat = Int32.Parse("2");
            int nEnd = Int32.Parse("254");
            for (int i = nStrat; i <= nEnd; i++)
            {
                try
                {
                    Int32 ldest = inet_addr(strIPAddress + "." + i); //将IP地址从 点数格式转换成无符号长整型
                    Int64 macinfo = new Int64();
                    Int32 len = 6;
                    SendARP(ldest, 0, ref macinfo, ref len);
                    if (macinfo == 0)  return strIPAddress + "." + i;
                }
                catch { }
            }
            return null;
        }
    }
}
